"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseObserver = void 0;
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
class BaseObserver {
  constructor() {
    _defineProperty(this, "listeners", void 0);
    this.listeners = new Set();
  }
  registerListener(listener) {
    this.listeners.add(listener);
    return () => {
      this.listeners.delete(listener);
    };
  }
  iterateListeners(cb) {
    for (const listener of this.listeners) {
      cb(listener);
    }
  }
}
exports.BaseObserver = BaseObserver;
//# sourceMappingURL=BaseObserver.js.map